#ifndef _LISTS_H
#define _LISTS_H

#include <iostream.h>

template <class Ltype> class Link
{
public:
  Link(Ltype *);
  Ltype *data;
  Link<Ltype> *next;
  Link<Ltype> *previous;
  List<Ltype> *owner;
};

template <class Ltype> class List
{
public:
  List(Link<Ltype> **, int number);
  ~List();

  void Add(Ltype *);
  void Remove(Ltype *);
  void RemoveAll();
  
  void Reset();
  Ltype *Next();

  int NumElements();
  int Member(Ltype *);
  void TestPrint(ostream &);
protected:
  Link<Ltype> *myHead;
  Link<Ltype> *myCurrent;
  int myNumElements;
  Link<Ltype> **myLookup;
  int myMax;
};

template <class Ltype> class ListGenerator
{
public:
  ListGenerator(Ltype **, int number);
  List<Ltype> *GenerateList();
protected:
  Link<Ltype> **myLookup;
  int myMax;
};

#endif
